{$R-,S-,I-,D-,T-,F-,V-,B-,N-,L- }

unit env;

interface
uses dos;


var fits_in_env: boolean;

function wildcards_in(path: pathstr): boolean;

function lowcase(C: char): char;

function StrLowCase(S : String): String;

function StrUpCase(s: string): string;

function getenv(envvar: string): string;

function getprogramname: pathstr;

function getprogrampath: pathstr;

function getshortprogramname: namestr;

function findinpath(filename: pathstr): pathstr;
         {er wordt gezocht naar executable files op de DOS-manier}

procedure setenv(envvar, envval: string);


implementation

type ptrrec = record offset, segment: word end;

function wildcards_in(path: pathstr): boolean;

begin
  wildcards_in:= pos('?', path) <> pos('*', path)     {dus niet beide nul}
end;


function lowcase(C: char): char;

begin
  if C in ['A'..'Z'] then inc(C, 32);
  lowcase:= c
end;


function StrLowCase(S : String): String;

var t: byte;
begin
  for t:= 1 to Length(S) do s[t]:= lowcase(s[t]);
  strlowcase:= S;
end;


function StrUpCase(s: string): string;

var t: byte;
begin
  for t:= 1 to Length(S) do S[t] := UpCase(S[t]);
  StrUpCase := S;
end;


function getenv(envvar: string): string;

var s: string;
    p: ^char;
begin
  p:= ptr(word(ptr(prefixseg, $2c)^),0);
  envvar:= strupcase(envvar) + '=';
  while p^ <> #0 do
  begin
    s:= '';
    repeat s:= s + p^; inc(ptrrec(p).offset) until p^ = #0;
    if pos(envvar, s) = 1 then
    begin
      getenv:= copy(s, succ(byte(envvar[0])), byte(s[0]));
      exit
    end;
    inc(ptrrec(p).offset);
  end;
  getenv:= ''
end;


function getprogramname;

var s: pathstr;
    p: pointer;
begin
  p:= ptr(word(ptr(prefixseg, $2c)^),0);
  while word(p^) <> 0 do
  begin
    inc(ptrrec(p).offset);
  end;
  inc(ptrrec(p).offset, 4);
  s:= '';
  repeat s:= s + char(p^); inc(ptrrec(p).offset) until byte(p^) = 0;
  getprogramname:= s
end;


function getprogrampath;

var dir:  dirstr;
    name: namestr;
    ext:  extstr;
begin
  fsplit(getprogramname, dir, name, ext);
  getprogrampath:= dir;
end;


function getshortprogramname;

var dir:  dirstr;
    name: namestr;
    ext:  extstr;
begin
  fsplit(getprogramname, dir, name, ext);
  getshortprogramname:= name;
end;


function findindir(dir: dirstr; name: namestr; ext: extstr): pathstr;
var fr: searchrec;
    s:  pathstr;
begin
  if ext = '' then
  begin
    s:= findindir(dir, name, '.com');
    if s = '' then s:= findindir(dir, name, '.exe');
    findindir:= s;
  end else
  begin
    findfirst(dir+name+ext, anyfile, fr);
    if doserror = 0 then findindir:= dir+name+ext
    else findindir:= ''
  end
end;


function findinpath(filename: pathstr): pathstr;

var path: pathstr;
    dir:  dirstr;
    name: namestr;
    ext:  extstr;
    s:    pathstr;
begin
  s:= '';
  fsplit(filename, dir, name, ext);
  if not wildcards_in(filename) then
  begin
    if dir = '' then path:= getenv('path') + ';'
    else path:= '';
    if (pos('.', path) = 0) or (path = '') then
      s:= findindir(dir, name, ext);
    while (length(path) > 0) and (s = '') do
    begin
      dir:= copy(path, 1, pred(pos(';', path)));
      if dir[length(dir)] <> '\' then dir:= dir + '\';
      s:= findindir(dir, name, ext);
      delete(path, 1, pos(';', path))
    end;
  end;
  findinpath:= strupcase(s)
end;


procedure setenv(envvar, envval: string);
var environment,
    max_size_of_env,
    actual_size_of_env,
    future_size_of_env:   word;
    p_get,
    p_set:                ^char;
    b:                    byte;
    tail_store:           string;
    length_old_var:       byte;

  procedure clear_env(envvar: string);
  var s: string;
  begin
    p_get:= ptr(environment, 0);
    envvar:= strupcase(envvar) + '=';
    while p_get^ <> #0 do
    begin
      p_set:= p_get;
      s:= '';
      while p_get^ <> #0 do
      begin
        s:= s + p_get^;
        inc(longint(p_get))
      end;
      if pos(envvar, s) = 1 then
      begin
        inc(longint(p_get));
        while ptrrec(p_get).offset < actual_size_of_env do
        begin
          p_set^:= p_get^;
          inc(longint(p_set));
          inc(longint(p_get));
        end;
        exit
      end;
      inc(longint(p_get));
    end;
  end;

begin
  environment:= word(ptr(prefixseg, $2c)^);
  p_get:= ptr(environment, 0);
  max_size_of_env:= $10 * word(ptr(environment-1, 3)^);
  while p_get^ <> #0 do
  begin
    while p_get^ <> #0 do inc(longint(p_get));
    inc(longint(p_get))
  end;
  inc(longint(p_get));
  inc(longint(p_get));
  for b:= 1 to byte(pointer(pred(longint(p_get)))^) do
  begin
    repeat inc(longint(p_get)) until p_get^ = #0;
  end;
  actual_size_of_env:= ptrrec(p_get).offset+1;
                   {first look wether it will fit}
  length_old_var:= length(getenv(envvar));
  if length_old_var = 0 then
  begin
    fits_in_env:= (envval = '') or
    (max_size_of_env >= (actual_size_of_env+length(envvar)+length(envval)+2))
  end
  else
  begin
    fits_in_env:= (envval = '') or
    (max_size_of_env >= (actual_size_of_env-length_old_var+length(envval)))
  end;
  if not fits_in_env then exit;
                   {adjust actual size}
  if length_old_var <> 0 then
  begin
                   {clear variable}
    clear_env(envvar);
    actual_size_of_env:= actual_size_of_env-length_old_var-length(envvar)-2
  end;
  if envval = '' then exit;
                   {go to end of environment}
  p_get:= ptr(environment, 0);
  while p_get^ <> #0 do
  begin
    while p_get^ <> #0 do inc(longint(p_get));
    inc(longint(p_get))
  end;
  p_set:= p_get;
                   {store rest (programname etc.)}
  tail_store:= '';
  for b:= ptrrec(p_get).offset to actual_size_of_env-1 do
  begin
    tail_store:= tail_store + char(ptr(environment, b)^)
  end;
                   {write new value}
  for b:= 1 to length(envvar) do
  begin
    p_set^:= upcase(envvar[b]);
    inc(longint(p_set))
  end;
  p_set^:= '=';
  inc(longint(p_set));
  for b:= 1 to length(envval) do
  begin
    p_set^:= envval[b];
    inc(longint(p_set))
  end;
  p_set^:= #0;
                   {restore rest in the back}
  inc(longint(p_set));
  for b:= 1 to length(tail_store) do
  begin
    p_set^:= tail_store[b];
    inc(longint(p_set))
  end;
end;

end.
